/* COMP 211, Fall 2021
 *
 * Trees and searching
 */

#include <stdio.h>
#include <stdlib.h>

#include "btree.h"

/*
 * Create an empty binary btree
 */
btree* empty()
{
    btree *t = malloc(sizeof(btree));
    t->root = NULL;
    return t;
}

/*
 * Insert a node
 */
void insert(btree *t, int key)
{
    bnode *n = malloc(sizeof(bnode));
    n->key = key;
    n->left = NULL;
    n->right = NULL;

    // Tree is empty
    if (t->root == NULL) {
        t->root = n;
        return;
    }

    // Tree is not empty
    bnode *temp = t->root;
    while (temp != NULL) {
        bnode* prev = temp;
        if (key == temp->key) {
            return;
        } else if (key < temp->key) {
            temp = temp->left;
            if (temp == NULL) prev->left = n;
        } else {
            temp = temp->right;
            if (temp == NULL) prev->right = n;
        }
    }
}

/*
 * Iterative search
 */
bool search(btree *t, int key)
{
    // ADD CODE HERE + CHANGE RETURN VALUE

    return false;
}

/*
 * Recursive search
 */
bool searchr(bnode* n, int key)
{
    // ADD CODE HERE + CHANGE RETURN VALUE

    return false;
}

/*
 * Preorder traversal: recursive
 */
void preorder(bnode *n)
{
    // ADD CODE HERE
}

/*
 * Postorder traversal: recursive
 */
void postorder(bnode* n)
{
    // ADD CODE HERE
}

/*
 * Inorder traversal: recursive
 */
void inorder(bnode* n)
{
    if (n == NULL) return;
    inorder(n->left);
    printf("%d ", n->key);
    inorder(n->right);
}

/*
 * Display tree contents: preorder
 */
void print_preorder(btree *t)
{
    printf("Values in tree, preorder: ");
    preorder(t->root);
    printf("\n");
}

/*
 * Display tree contents; postorder
 */
void print_postorder(btree *t)
{
    printf("Values in tree, postorder: ");
    postorder(t->root);
    printf("\n");
}

/*
 * Display tree contents: inorder
 */
void print_inorder(btree *t)
{
    printf("Values in tree, inorder: ");
    inorder(t->root);
    printf("\n");
}

