/* COMP 211, Fall 2021
 * Lab 12
 *
 * Trees and searching
 */

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

#include "btree.h"

struct menu_opt {
    char* desc;
    void (*act)(void);
};

struct btree *t = NULL;

void do_exit() { exit(0); }

void do_make_empty() {
    t = empty();
};

void do_insert() {
    int key;
    printf("Enter key value of node to insert: ");
    scanf(" %d", &key);
    insert(t, key);
}

void do_search(){
    int key;
    printf("Enter key value to search for: ");
    scanf(" %d", &key);
    bool found = search(t, key);
    if (found) {
        printf("Key %d was found\n", key);
    } else {
        printf("Key %d was not found\n", key);
    }
};

void do_searchr() {
    int key;
    printf("Enter key value to search for: ");
    scanf(" %d", &key);
    bool found = searchr(t->root, key);
    if (found) {
        printf("Key %d was found\n", key);
    } else {
        printf("Key %d was not found\n", key);
    }
};

void do_print_inorder() {
    print_inorder(t);
};

void do_print_preorder() {
    print_preorder(t);
};

void do_print_postorder() {
    print_postorder(t);
};

int main(int argc, char **argv) {

    struct menu_opt menu[] = {
        {"Exit", do_exit},
        {"Create empty tree", do_make_empty},
        {"Insert key/node", do_insert},
        {"Iterative key search", do_search},
        {"Recursive key search", do_searchr},
        {"Print keys: preorder", do_print_preorder},
        {"Print keys: postorder", do_print_postorder},
        {"Print keys: inorder", do_print_inorder}
    };

    // WARNING:  this method for computing the size of an array only works when
    // the array is declared on the stack.  In particular, it is not valid when
    // the array is allocated using malloc, calloc, etc.
    int n_menu = sizeof(menu)/sizeof(struct menu_opt);

    int choice;

    while (true) {
        for (int i=0; i<n_menu; ++i) {
            printf("(%d) %s\n", i, menu[i].desc);
        }
        printf("Enter choice: ");
        scanf("%u", &choice);
        menu[choice].act();
    }

    return 0;
}
